import {Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards} from "@nestjs/common";
import {AdminAuthGuard} from "src/core/guards/admin-auth.guard";
import {Constants} from "src/utils/constants";
import { UpdateFooterBannerCmsDto } from "./dto/update-footer-banner-cms.dto";
import { FooterBannerCmsService } from "./footer-banner-cms.service";

@Controller({path: "footer-banner-cms", version: Constants.API_VERSION_1})

export class FooterBannerCmsController {
    constructor(private readonly service: FooterBannerCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
        @Body() dto: UpdateFooterBannerCmsDto,
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
