import { EntityRepository, Repository } from "typeorm";
import { HomePageOurProductsSectionCmsEntity } from "./entities/home-page-our-products-section-cms.entity";
import { UpdateHomePageOurProductsSectionCmsDto } from "./dto/update-home-page-our-products-section-cms.dto";

@EntityRepository(HomePageOurProductsSectionCmsEntity)
export class HomePageOurProductsSectionCmsRepository extends Repository<HomePageOurProductsSectionCmsEntity> {

    async createEntity(dto: UpdateHomePageOurProductsSectionCmsDto): Promise<HomePageOurProductsSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                heading: dto.heading,
                title: dto.title
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageOurProductsSectionCmsDto, id: string): Promise<HomePageOurProductsSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                heading: dto.heading,
                title: dto.title
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageOurProductsSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}