import {EntityRepository, Repository} from "typeorm";
import { TermsAndConditionPageCmsEntity } from "./entities/terms-and-condition-page-cms.entity";
import { UpdateTermsAndConditionPageCmsDto } from "./dto/update-terms-and-condition-page-cms.dto";

@EntityRepository(TermsAndConditionPageCmsEntity)
export class TermsAndConditionPageCmsRepository extends Repository<TermsAndConditionPageCmsEntity> {

    async createEntity(dto: UpdateTermsAndConditionPageCmsDto): Promise<TermsAndConditionPageCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subtitle: dto.subtitle,
                description: dto.description
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateTermsAndConditionPageCmsDto, id: string): Promise<TermsAndConditionPageCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subtitle: dto.subtitle,
                description: dto.description
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<TermsAndConditionPageCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}