import { DashboardService } from './dashboard.service';
import { DashboardController } from './dashboard.controller';
import { Module } from '@nestjs/common';
import { JwtModule } from '@nestjs/jwt';
import JwtConfigService from '../../core/jwt/jwt-config.service';
import JwtHelper from '../../core/jwt/jwt.helper';
import { TypeOrmModule } from '@nestjs/typeorm';
import { UsersRepository } from '../users/user.repository';
import { OrderRepository } from '../orders/order/order-repository';
import { ProductsRepository } from '../product/product/product.repository';
import { BlogPostRepository } from '../blog-post/blog-post.repository';


@Module({
    imports: [
        TypeOrmModule.forFeature([
            UsersRepository, 
            ProductsRepository, 
            OrderRepository,
            BlogPostRepository,
        ]),
        JwtModule.registerAsync({ useClass: JwtConfigService })
    ],
    controllers: [DashboardController],
    providers: [DashboardService, JwtHelper]
})

export class DashboardModule {}
