import { IsEmpty, IsNotEmpty } from "class-validator";

export class CreateOrderByAdminDto {
    @IsNotEmpty()
    readonly customerName: string;

    @IsNotEmpty()
    readonly email: string;

    @IsNotEmpty()
    readonly contactNo: string;

    @IsNotEmpty()
    readonly shippingAddress: string;

    @IsNotEmpty()
    readonly coupon: string;

    @IsNotEmpty()
    readonly itemSubTotal: number;

    @IsNotEmpty()
    readonly itemTotal: number;

    @IsNotEmpty()
    readonly shippingCost: string;

    @IsEmpty()
    shippingType: string;

    @IsEmpty()
    serviceType: string;

    @IsEmpty()
    weightValue: number;

    @IsNotEmpty()
    readonly products: [Object];

    @IsNotEmpty()
    readonly discountType: string;

    @IsNotEmpty()
    readonly discountAmount: string;

    @IsNotEmpty()
    readonly discountTotal: string;

    @IsNotEmpty()
    readonly salesTaxTitle: string;

    @IsNotEmpty()
    readonly salesTaxRate: number;

    @IsNotEmpty()
    readonly salesTaxAmount: number;

    @IsNotEmpty()
    readonly totalDiscount: number;

    @IsNotEmpty()
    readonly paymentMethodName: string;

    @IsEmpty()
    amount: number;

    @IsEmpty()
    ccNum: string;

    @IsEmpty()
    ccExp: string;

    @IsEmpty()
    cvv: string;

    @IsEmpty()
    paymentStatus: string;
}
