import { Module } from '@nestjs/common';
import { OrderService } from './orders.service';
import { OrderController } from './orders.controller';
import { TypeOrmModule } from "@nestjs/typeorm";
import { ProductsRepository } from "src/modules/product/product/product.repository";
import { CouponRepository } from "../coupon/coupon.repository";
import { SalesTaxCMSRepository } from "src/modules/CMS/sales-tax-cms/sales-tax-cms.repository";
import { OrderDetailsRepository } from "../order-details/order-details.repository";
import { PaymentConfigurationRepository } from "src/modules/payment-configuration/payment-configuration.repository";
import { PaymentGatewayRepository } from "src/modules/payment-gateway/payment-gateway.repository";
import { OrderRepository } from "./order-repository";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import { UsersRepository } from "src/modules/users/user.repository";
import JwtHelper from "src/core/jwt/jwt.helper";
import { MailSenderService } from "src/modules/mail-sender/mail-sender.service";
import { UpsShippingService } from "src/modules/ups/ups-shipping/ups-shipping.service";
import { UpsCoreService } from "src/modules/ups/ups-core/ups-core.service";
import { ReturnProductsRepository } from "src/modules/return-products/return-products.repository";
import { RefundItemRepository } from "src/modules/refund-item/refund-item.repository";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";
import { UpsConfigurationRepository } from "src/modules/ups-configuration/ups-configuration.repository";
import { NewsletterRepository } from 'src/modules/CRUD/newsletter/newsletter.repository';

@Module({
    imports: [
        TypeOrmModule.forFeature([
            OrderRepository,
            ProductsRepository,
            CouponRepository,
            SalesTaxCMSRepository,
            OrderDetailsRepository,
            PaymentConfigurationRepository,
            PaymentGatewayRepository,
            UsersRepository,
            ReturnProductsRepository,
            RefundItemRepository,
            UpsConfigurationRepository,
            NewsletterRepository,
        ]),
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
    ],
    controllers: [OrderController],
    providers: [OrderService, JwtHelper, MailSenderService, UpsShippingService, UpsCoreService, DoSpacesService, DoSpacesServicerovider]
})
export class OrderModule { }
