import { EntityRepository, Repository } from "typeorm";
import { UpdatePaymentConfigurationDto } from "./dto/update-payment-configuration.dto";
import { PaymentConfiguration } from "./entities/payment-configuration.entity";

@EntityRepository(PaymentConfiguration)
export class PaymentConfigurationRepository extends Repository<PaymentConfiguration> {

    async createEntity(dto: UpdatePaymentConfigurationDto): Promise<PaymentConfiguration | Error> {
        try {
            const entity = this.create({
                securityKey: dto.securityKey
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdatePaymentConfigurationDto, id: string): Promise<PaymentConfiguration | Error> {
        try {
            await this.update(id, {
                securityKey: dto.securityKey
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PaymentConfiguration[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}