import { EntityRepository, getConnection, Repository } from "typeorm";
import { CreateProductDumpImportDto } from "./dto/create-product-dump-import.dto";
import { UpdateProductDumpImportDto } from "./dto/update-product-dump-import.dto";
import { ProductDumpImport } from "./entity/product-dump-import.entity";

@EntityRepository(ProductDumpImport)
export class ProductDumpImportRepository extends Repository<ProductDumpImport> {

    async createEntity(
        dto: CreateProductDumpImportDto
    ): Promise<ProductDumpImport | Error> {
        try {
            const { DumpID, Name, Sku, Cost, Price, DiscountPrice, Stock, Weight, Color } = dto;
            const entity = this.create({ DumpID, Name, Sku, Cost, Price, DiscountPrice, Stock, Weight, Color });
            await this.save(entity);
            return entity;
        }
        catch (e) {
            return e;
        }
    }

    async findByFilterQuery(query: any): Promise<ProductDumpImport[] | Error> {
        try {
            return await this.find({
                where: { ...query, isDeleted: false }
            });
        }
        catch (e) {
            return e;
        }
    }
}