import { HttpException, HttpStatus, Injectable, NotFoundException } from '@nestjs/common';
import { Constants } from 'src/utils/constants';
import { ResponseUtils } from 'src/utils/response.utils';
import { AboutPageSectionOneCmsRepository } from '../CMS/about-page-section-one-cms/about-page-section-one-cms.repository';
import { InjectRepository } from '@nestjs/typeorm';
import { AboutPageSectionTwoCmsRepository } from '../CMS/about-page-section-two-cms/about-page-section-two-cms.repository';
import { AboutPageOurMissionSectionCmsRepository } from '../CMS/about-page-our-mission-section-cms/about-page-our-mission-section-cms.repository';
import { AboutPageOurCommunitySectionCmsRepository } from '../CMS/about-page-our-community-section-cms/about-page-our-community-section-cms.repository';
import { AboutPageOpenSourceCommunitySectionCmsRepository } from '../CMS/about-page-open-source-community-section-cms/about-page-open-source-community-section-cms.repository';
import { FaqPageCmsRepository } from '../CMS/faq-page-cms/faq-page-cms.repository';
import { FAQRepository } from '../CRUD/faq/faq.repository';
import { ContactPageCmsRepository } from '../CMS/contact-page-cms/contact-page-cms.repository';
import { BlogPostRepository } from '../blog-post/blog-post.repository';
import { HomePageHeroSectionRepository } from '../CRUD/home-page-hero-section/home-page-hero-section.repository';
import { HomePageAboutSectionCmsRepository } from '../CMS/home-page-about-section-cms/home-page-about-section-cms.repository';
import { HomePageBannerSectionCmsRepository } from '../CMS/home-page-banner-section-cms/home-page-banner-section-cms.repository';
import { HomePageDiscoverSectionCmsRepository } from '../CMS/home-page-discover-section-cms/home-page-discover-section-cms.repository';
import { HomePageOurProductsSectionCmsRepository } from '../CMS/home-page-our-products-section-cms/home-page-our-products-section-cms.repository';
import { HeaderFooterCmsRepository } from '../CMS/header-footer-cms/header-footer-cms.repository';
import { FooterBannerCmsRepository } from '../CMS/footer-banner-cms/footer-banner-cms.repository';
import { SocialLinksRepository } from '../CRUD/social-links/social-links.repository';
import { HomePagePackageSectionCmsRepository } from '../CMS/home-page-package-section-cms/home-page-package-section-cms.repository';
import { HomePageBlogSectionCmsRepository } from '../CMS/home-page-blog-section-cms/home-page-blog-section-cms.repository';
import { HomePageTestimonialSectionCmsRepository } from '../CMS/home-page-testimonial-section-cms/home-page-testimonial-section-cms.repository';
import { HomePageInstagramSectionCmsRepository } from '../CMS/home-page-instagram-section-cms/home-page-instagram-section-cms.repository';
import { HomePageAboutSectionRepository } from '../CRUD/home-page-about-section/home-page-about-section.repository';
import { HomePagePromotionSectionRepository } from '../CRUD/home-page-promotion-section/home-page-promotion-section.repository';
import { TestimonialsRepository } from '../CRUD/testimonials/testimonials.repository';
import { InstagramServiceRepository } from '../CRUD/instagram-service/instagram-service.repository';
import { ShippingAddressRepository } from '../address/shipping-address/shipping-address.repository';
import { BillingAddressRepository } from '../address/billing-address/billing-address.repository';
import { ProductsRepository } from '../product/product/product.repository';
import { Product } from '../product/product/entity/product.entity';
import { ProductColorVariantsRepository } from '../product/product-color-variants/product-color-variants.repository';
import { ProductOfferVariantsRepository } from '../product/product-offer-variants/product-offer-variants.repository';
import { ProductImageGalleryRepository } from '../product/product-image-gallery/product-image-gallery.repository';
import { ProductReviewRepository } from '../product/product-review/product-review.repository';
import { RefundPolicyCmsRepository } from '../CMS/refund-policy-cms/refund-policy-cms.repository';
import { PurchaseAndDeliveryPolicyCmsRepository } from '../CMS/purchase-and-delivery-policy-cms/purchase-and-delivery-policy-cms.repository';
import { PurchaseAndDeliveryPolicyRepository } from '../CRUD/purchase-and-delivery-policy/purchase-and-delivery-policy.repository';
import { SalesTaxCMSRepository } from '../CMS/sales-tax-cms/sales-tax-cms.repository';
import { CouponRepository } from '../orders/coupon/coupon.repository';
import { PackagesRepository } from '../CRUD/packages/packages.repository';
import { HomePageComponentUiRepository } from '../component-ui/home-page-component-ui/home-page-component-ui.repository';

@Injectable()
export class SiteFrontendService {
    constructor(
        @InjectRepository(AboutPageSectionOneCmsRepository)
        private readonly aboutPageSectionOneCmsRepository: AboutPageSectionOneCmsRepository,
        @InjectRepository(AboutPageSectionTwoCmsRepository)
        private readonly aboutPageSectionTwoCmsRepository: AboutPageSectionTwoCmsRepository,
        @InjectRepository(AboutPageOurMissionSectionCmsRepository)
        private readonly aboutPageOurMissionSectionCmsRepository: AboutPageOurMissionSectionCmsRepository,
        @InjectRepository(AboutPageOurCommunitySectionCmsRepository)
        private readonly aboutPageOurCommunitySectionCmsRepository: AboutPageOurCommunitySectionCmsRepository,
        @InjectRepository(AboutPageOpenSourceCommunitySectionCmsRepository)
        private readonly aboutPageOpenSourceCommunitySectionCmsRepository: AboutPageOpenSourceCommunitySectionCmsRepository,
        @InjectRepository(FaqPageCmsRepository)
        private readonly faqPageCmsRepository: FaqPageCmsRepository,
        @InjectRepository(FAQRepository)
        private readonly faqRepository: FAQRepository,
        @InjectRepository(ContactPageCmsRepository)
        private readonly contactPageCmsRepository: ContactPageCmsRepository,
        @InjectRepository(BlogPostRepository)
        private readonly blogPostRepository: BlogPostRepository,
        @InjectRepository(HomePageHeroSectionRepository)
        private readonly homePageHeroSectionRepository: HomePageHeroSectionRepository,
        @InjectRepository(HomePageAboutSectionCmsRepository)
        private readonly homePageAboutSectionCmsRepository: HomePageAboutSectionCmsRepository,
        @InjectRepository(HomePageBannerSectionCmsRepository)
        private readonly homePageBannerSectionCmsRepository: HomePageBannerSectionCmsRepository,
        @InjectRepository(HomePageDiscoverSectionCmsRepository)
        private readonly homePageDiscoverSectionCmsRepository: HomePageDiscoverSectionCmsRepository,
        @InjectRepository(HomePageOurProductsSectionCmsRepository)
        private readonly homePageOurProductsSectionCmsRepository: HomePageOurProductsSectionCmsRepository,
        @InjectRepository(HeaderFooterCmsRepository)
        private readonly headerFooterCmsRepository: HeaderFooterCmsRepository,
        @InjectRepository(FooterBannerCmsRepository)
        private readonly footerBannerCmsRepository: FooterBannerCmsRepository,
        @InjectRepository(SocialLinksRepository)
        private readonly socialLinksRepository: SocialLinksRepository,
        @InjectRepository(HomePagePackageSectionCmsRepository)
        private readonly homePagePackageSectionCmsRepository: HomePagePackageSectionCmsRepository,
        @InjectRepository(PackagesRepository)
        private readonly packagesRepository: PackagesRepository,
        @InjectRepository(HomePageBlogSectionCmsRepository)
        private readonly homePageBlogSectionCmsRepository: HomePageBlogSectionCmsRepository,
        @InjectRepository(HomePageTestimonialSectionCmsRepository)
        private readonly homePageTestimonialSectionCmsRepository: HomePageTestimonialSectionCmsRepository,
        @InjectRepository(HomePageInstagramSectionCmsRepository)
        private readonly homePageInstagramSectionCmsRepository: HomePageInstagramSectionCmsRepository,
        @InjectRepository(HomePageAboutSectionRepository)
        private readonly homePageAboutSectionRepository: HomePageAboutSectionRepository,
        @InjectRepository(HomePagePromotionSectionRepository)
        private readonly homePagePromotionSectionRepository: HomePagePromotionSectionRepository,
        @InjectRepository(TestimonialsRepository)
        private readonly testimonialsRepository: TestimonialsRepository,
        @InjectRepository(InstagramServiceRepository)
        private readonly instagramServiceRepository: InstagramServiceRepository,
        @InjectRepository(BillingAddressRepository)
        private readonly billingAddressRepository: BillingAddressRepository,
        @InjectRepository(ShippingAddressRepository)
        private readonly shippingAddressRepository: ShippingAddressRepository,
        @InjectRepository(ProductsRepository)
        private readonly productsRepository: ProductsRepository,
        @InjectRepository(ProductColorVariantsRepository)
        private readonly productColorVariantsRepository: ProductColorVariantsRepository,
        @InjectRepository(ProductOfferVariantsRepository)
        private readonly productOfferVariantsRepository: ProductOfferVariantsRepository,
        @InjectRepository(ProductImageGalleryRepository)
        private readonly productImageGalleryRepository: ProductImageGalleryRepository,
        @InjectRepository(ProductReviewRepository)
        private readonly productReviewRepository: ProductReviewRepository,
        @InjectRepository(RefundPolicyCmsRepository)
        private readonly refundPolicyCmsRepository: RefundPolicyCmsRepository,
        @InjectRepository(PurchaseAndDeliveryPolicyCmsRepository)
        private readonly purchaseAndDeliveryPolicyCmsRepository: PurchaseAndDeliveryPolicyCmsRepository,
        @InjectRepository(PurchaseAndDeliveryPolicyRepository)
        private readonly purchaseAndDeliveryPolicyRepository: PurchaseAndDeliveryPolicyRepository,
        @InjectRepository(SalesTaxCMSRepository)
        private readonly salesTaxCMSRepository: SalesTaxCMSRepository,
        @InjectRepository(CouponRepository)
        private readonly couponRepository: CouponRepository,
        @InjectRepository(HomePageComponentUiRepository)
        private readonly homePageComponentUiRepository: HomePageComponentUiRepository,
    ) { }

    async getAboutPageData() {
        const sectionOneCmsData = await this.aboutPageSectionOneCmsRepository.findAll();
        const sectionTwoCmsData = await this.aboutPageSectionTwoCmsRepository.findAll();
        const ourMissionSectionCmsData = await this.aboutPageOurMissionSectionCmsRepository.findAll();
        const ourCommunitySectionCmsData = await this.aboutPageOurCommunitySectionCmsRepository.findAll();
        const openSourceCommunitySectionCmsData = await this.aboutPageOpenSourceCommunitySectionCmsRepository.findAll();

        const responseData = {
            sectionOneCmsData: sectionOneCmsData,
            sectionTwoCmsData: sectionTwoCmsData,
            ourMissionSectionCmsData: ourMissionSectionCmsData,
            ourCommunitySectionCmsData: ourCommunitySectionCmsData,
            openSourceCommunitySectionCmsData: openSourceCommunitySectionCmsData
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', responseData);
    }

    async getFaqPageData() {
        const pageCmsData = await this.faqPageCmsRepository.findAll();
        const faqData = await this.faqRepository.findByFilterQuery({});

        const responseData = {
            pageCmsData: pageCmsData,
            faqData: faqData
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', responseData);
    }

    async getContactPageData() {
        const pageCmsData = await this.contactPageCmsRepository.findAll();
        const socialLinkData = await this.socialLinksRepository.findByFilterQuery({});

        const responseData = {
            pageCmsData: pageCmsData,
            socialLinkData: socialLinkData
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', responseData);
    }

    async getBlogListData(
        page: number,
        limit: number
    ): Promise<any | Error> {
        const blogList = await this.blogPostRepository.findBlogByFilterQuery(page, limit);

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', blogList);
    }

    async getBlogDetailsData(urlSlug: string): Promise<any | Error> {
        const blogData = await this.blogPostRepository.findOneEntityBySlug(urlSlug);
        const latestBlogList = await this.blogPostRepository.getLatestBlogList();
        const promotionSectionData = await this.homePagePromotionSectionRepository.findByFilterQuery({});

        let data = {
            blogData: blogData,
            latestBlogList: latestBlogList,
            promotionSectionData: promotionSectionData
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', data);
    }

    async getHomePageData() {
        const heroSectionData = await this.homePageHeroSectionRepository.findByFilterQuery({});
        const aboutSectionCMS = await this.homePageAboutSectionCmsRepository.findAll();
        const bannerSectionCMS = await this.homePageBannerSectionCmsRepository.findAll();
        const discoverSectionCMS = await this.homePageDiscoverSectionCmsRepository.findAll();
        const ourProductsSectionCMS = await this.homePageOurProductsSectionCmsRepository.findAll();
        const packageSectionCMS = await this.homePagePackageSectionCmsRepository.findAll();
        const packageData = await this.packagesRepository.findByFilterQuery({});
        const blogSectionCMS = await this.homePageBlogSectionCmsRepository.findAll();
        const testimonialSectionCMS = await this.homePageTestimonialSectionCmsRepository.findAll();
        const instagramSectionCMS = await this.homePageInstagramSectionCmsRepository.findAll();
        const promotionSectionData = await this.homePagePromotionSectionRepository.findByFilterQuery({});
        const aboutSectionData = await this.homePageAboutSectionRepository.findByFilterQuery({});
        const latestBlogList = await this.blogPostRepository.getLatestBlogList();
        const testimonialData = await this.testimonialsRepository.findByFilterQuery({});
        const instagramData = await this.instagramServiceRepository.findByFilterQuery({});
        const componentUIData = await this.homePageComponentUiRepository.findAll();

        const responseData = {
            heroSectionData: heroSectionData,
            aboutSectionCMS: aboutSectionCMS,
            bannerSectionCMS: bannerSectionCMS,
            ourProductsSectionCMS: ourProductsSectionCMS,
            discoverSectionCMS: discoverSectionCMS,
            packageSectionCMS: packageSectionCMS,
            packageData: packageData,
            promotionSectionData: promotionSectionData,
            blogSectionCMS: blogSectionCMS,
            latestBlogList: latestBlogList,
            testimonialSectionCMS: testimonialSectionCMS,
            testimonialData: testimonialData,
            instagramSectionCMS: instagramSectionCMS,
            aboutSectionData: aboutSectionData,
            instagramData: instagramData,
            componentUIData: componentUIData,
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', responseData);
    }

    async getHeaderFooterData() {
        const socialLinkData = await this.socialLinksRepository.findByFilterQuery({});
        const headerFooterCMS = await this.headerFooterCmsRepository.findAll();
        const footerBannerCMS = await this.footerBannerCmsRepository.findAll();

        const responseData = {
            socialLinkData: socialLinkData,
            headerFooterCMS: headerFooterCMS,
            footerBannerCMS: footerBannerCMS
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', responseData);
    }

    async getUserAddresses(userId: string): Promise<any | Error> {
        const billingAddresses = await this.billingAddressRepository.findByFilterQuery({ userId: userId });
        const shippingAddresses = await this.shippingAddressRepository.findByFilterQuery({ userId: userId });
        
        const response = {
            billingAddresses,
            shippingAddresses
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', response);
    }

    async findOneBySlug(slug: string): Promise<any | Error> {
        try {
            const productData = await this.productsRepository.findOneProductBySlug(slug);
            if (!productData) {
                // throw new NotFoundException(Constants.NOT_FOUND);
                return ResponseUtils.errorResponseHandler(400, 'Product not found!');
            }
            const product = productData as Product;
            const colorVariants = await this.productColorVariantsRepository.findByFilterQuery({ productId: product.id });
            const offerVariants = await this.productOfferVariantsRepository.findOffersByProductId(product.id);
            const imageGallery = await this.productImageGalleryRepository.findByFilterQuery({ productId: product.id });
            const reviews = await this.productReviewRepository.findAllWithUserInfo(product.id);
            const relatedProducts = await this.productsRepository.findByFilterQuery({});
            const refundPolicyCMS = await this.refundPolicyCmsRepository.findAll();
            const purchaseAndDeliveryPolicyCMS = await this.purchaseAndDeliveryPolicyCmsRepository.findAll();
            const promotionSectionData = await this.homePagePromotionSectionRepository.findByFilterQuery({});
            const purchaseAndDeliveryPolicyData = await this.purchaseAndDeliveryPolicyRepository.findByFilterQuery({});
            const data = {
                productData: productData,
                colorVariants: colorVariants,
                offerVariants: offerVariants,
                imageGallery: imageGallery,
                reviews: reviews,
                relatedProducts: relatedProducts,
                promotionSectionData: promotionSectionData,
                refundPolicyCMS: refundPolicyCMS,
                purchaseAndDeliveryPolicyCMS: purchaseAndDeliveryPolicyCMS,
                purchaseAndDeliveryPolicyData: purchaseAndDeliveryPolicyData
            };
            return ResponseUtils.successResponseHandler(200, 'Product data fetched Successfully!', 'data', data);
        } catch (e) {
            console.log(e);
            return e;
        }
    }

    async findAllProducts(
        limit: any,
        page: any
    ): Promise<any | Error> {
        const products = await this.productsRepository.findAllProducts(
            limit,
            page
        );

        if (!products) {
            throw new HttpException(Constants.NOT_FOUND, HttpStatus.NOT_FOUND);
        }
        
        const promotionSectionData = await this.homePagePromotionSectionRepository.findByFilterQuery({});

        const data = {
            productData: products,
            promotionSectionData: promotionSectionData,
        };

        return ResponseUtils.successResponseHandler(200, 'Products successfully fetched!', 'data', data);
    }

    async getSalesTaxAndCouponData() {
        const salesTaxData = await this.salesTaxCMSRepository.findAll();
        const coupon = await this.couponRepository.findByFilterQuery({});

        const responseData = {
            salesTaxData: salesTaxData,
            coupon: coupon
        };

        return ResponseUtils.successResponseHandler(200, 'Data fetched successfully', 'data', responseData);
    }
}
